<?php
// Copyright (C) 2013 Small Green Computer
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

//////////////////////////////////////////////
// get_system_info
// Get network and system name
//////////////////////////////////////////////

function get_system_info(){

$private_network_info = array();
$private_system_info = array(
'SYSNAME' => "",
'WORKGROUP' => "",
'BOOTPROTO' => "",
'IPADDR' => "",
'NETMASK' => "",
'GATEWAY' => "",
'DNS1' => "",
'DNS2' => "",
'DNS3' => "",
'HWADDR' => ""
);


//----------------------------------------------
// Get Network info
	$lines = file('/etc/sysconfig/network-scripts/ifcfg-eth0');
	
    foreach ($lines as $line_num=>$line) {
  if ( ! preg_match("/#.*/", $line) ) {
	# Contains non-whitespace?
	if ( preg_match("/\S/", $line) ) {
	list( $key, $value ) = explode( "=", trim( $line ), 2);
	$config[$key] = str_replace('"', '', $value);
	  if ( isset($private_system_info[$key])) {
		$private_system_info[$key] = trim($config[$key]);
	 }
	}
  }
 }
//----------------------------------------------
unset($lines);
$private_system_info['HWADDR'] = strtoupper(exec("/bin/cat /sys/class/net/eth0/address"));

return $private_system_info;
}

//////////////////////////////////////////////
// write_system_info
// write network and system name
//////////////////////////////////////////////

function write_system_info($private_system_info){

  global $dateTimeNow;

  if (empty($private_system_info['DNS1'])) { 
	$private_system_info['DNS1'] = "208.67.222.222";
	$private_system_info['DNS2'] = "208.67.220.220";
  }

  if ($fp = fopen('/var/tmp/ifcfg-eth0.new', 'w')) {
	fwrite($fp, "# Created by VortexBox web admin on ".$dateTimeNow."\n");
	  if ($private_system_info['BOOTPROTO'] == "none") {
		fwrite($fp, "DEVICE=eth0\n");
		fwrite($fp, "HWADDR=".$private_system_info['HWADDR']."\n");
		fwrite($fp, "BOOTPROTO=none\n");		
		fwrite($fp, "ONBOOT=yes\n");
		fwrite($fp, "NM_CONTROLLED=yes\n");
		fwrite($fp, "IPADDR=".$private_system_info['IPADDR']."\n");
		fwrite($fp, "NETMASK=".$private_system_info['NETMASK']."\n");
		fwrite($fp, "GATEWAY=".$private_system_info['GATEWAY']."\n");
		fwrite($fp, "DNS1=".$private_system_info['DNS1']."\n");	
		if (! empty($private_system_info['DNS2'])) { fwrite($fp, "DNS2=".$private_system_info['DNS2']."\n"); }
		if (! empty($private_system_info['DNS3'])) { fwrite($fp, "DNS3=".$private_system_info['DNS3']."\n"); }	

	  } else {
		fwrite($fp, "DEVICE=eth0\n");
		fwrite($fp, "HWADDR=".$private_system_info['HWADDR']."\n");
		fwrite($fp, "BOOTPROTO=dhcp\n");		
		fwrite($fp, "ONBOOT=yes\n");
		fwrite($fp, "NM_CONTROLLED=yes\n");
	  }

	} else {
		echo 'Config file unwritable... '; 
  }
	
  exec("sudo /opt/vamp/setup_network.sh $SYSNAME $WORKGROUP & >/dev/null 2>&1");
}
?>

